/*
 * Copyright © 2007 Intel Corporation
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
/*
 * DO NOT EDIT THIS FILE - it is generated by Glade.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)

GtkWidget*
create_main_win (void)
{
  GtkWidget *main_win;
  GtkWidget *vbox1;
  GtkWidget *hbox3;
  GtkWidget *label15;
  GtkWidget *xserver_entry;
  GtkWidget *label34;
  GtkWidget *about_btn;
  GtkWidget *label17;
  GtkWidget *hbox1;
  GtkWidget *scrolledwindow1;
  GtkWidget *viewport1;
  GtkWidget *vbox2;
  GtkWidget *label9;
  GtkWidget *output_iview;
  GtkWidget *label16;
  GtkWidget *setting_notebook;
  GtkWidget *frame1;
  GtkWidget *hbox5;
  GtkWidget *table3;
  GtkWidget *label24;
  GtkWidget *modes_combo;
  GtkWidget *vbox6;
  GtkWidget *label32;
  GtkWidget *auto_cbtn;
  GtkWidget *label33;
  GtkWidget *off_cbtn;
  GtkWidget *label6;
  GtkWidget *label2;
  GtkWidget *frame4;
  GtkWidget *alignment4;
  GtkWidget *hbox2;
  GtkWidget *rotation_img;
  GtkWidget *vbox3;
  GtkWidget *rotation0_rbtn;
  GSList *rotation0_rbtn_group = NULL;
  GtkWidget *rotation90_rbtn;
  GtkWidget *rotation180_rbtn;
  GtkWidget *rotation270_rbtn;
  GtkWidget *label13;
  GtkWidget *label3;
  GtkWidget *frame3;
  GtkWidget *alignment3;
  GtkWidget *vbox5;
  GtkWidget *hbox4;
  GtkWidget *clone_rbtn;
  GSList *clone_rbtn_group = NULL;
  GtkWidget *panorama_rbtn;
  GtkWidget *label31;
  GtkWidget *hseparator1;
  GtkWidget *table5;
  GtkWidget *scrolledwindow2;
  GtkWidget *center_iview;
  GtkWidget *scrolledwindow3;
  GtkWidget *left_iview;
  GtkWidget *scrolledwindow4;
  GtkWidget *right_iview;
  GtkWidget *scrolledwindow5;
  GtkWidget *above_iview;
  GtkWidget *scrolledwindow6;
  GtkWidget *below_iview;
  GtkWidget *label27;
  GtkWidget *label28;
  GtkWidget *label29;
  GtkWidget *label30;
  GtkWidget *label8;
  GtkWidget *label4;
  GtkWidget *vbox4;
  GtkWidget *hotkey_cbtn;
  GtkWidget *hotkey_tview;
  GtkWidget *label5;
  GtkWidget *hbuttonbox1;
  GtkWidget *ok_btn;
  GtkWidget *cancel_btn;
  GtkWidget *apply_btn;

  main_win = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_size_request (main_win, 580, -1);
  gtk_window_set_title (GTK_WINDOW (main_win), _("grandr"));
  gtk_window_set_resizable (GTK_WINDOW (main_win), FALSE);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (main_win), vbox1);

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox3, FALSE, TRUE, 0);

  label15 = gtk_label_new (_("  X Server      "));
  gtk_widget_show (label15);
  gtk_box_pack_start (GTK_BOX (hbox3), label15, FALSE, FALSE, 0);

  xserver_entry = gtk_entry_new ();
  gtk_widget_show (xserver_entry);
  gtk_box_pack_start (GTK_BOX (hbox3), xserver_entry, TRUE, TRUE, 0);
  gtk_widget_set_sensitive (xserver_entry, FALSE);
  gtk_entry_set_text (GTK_ENTRY (xserver_entry), _(":0.0"));
  gtk_entry_set_invisible_char (GTK_ENTRY (xserver_entry), 8226);

  label34 = gtk_label_new (_("       "));
  gtk_widget_show (label34);
  gtk_box_pack_start (GTK_BOX (hbox3), label34, FALSE, FALSE, 0);

  about_btn = gtk_button_new_with_mnemonic (_("  About  "));
  gtk_widget_show (about_btn);
  gtk_box_pack_start (GTK_BOX (hbox3), about_btn, FALSE, FALSE, 0);

  label17 = gtk_label_new ("");
  gtk_widget_show (label17);
  gtk_box_pack_start (GTK_BOX (vbox1), label17, FALSE, FALSE, 0);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (hbox1), scrolledwindow1, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_SHADOW_IN);

  viewport1 = gtk_viewport_new (NULL, NULL);
  gtk_widget_show (viewport1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), viewport1);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (viewport1), vbox2);

  label9 = gtk_label_new (_("Outputs     "));
  gtk_widget_show (label9);
  gtk_box_pack_start (GTK_BOX (vbox2), label9, FALSE, FALSE, 0);

  output_iview = gtk_icon_view_new ();
  gtk_widget_show (output_iview);
  gtk_box_pack_start (GTK_BOX (vbox2), output_iview, TRUE, TRUE, 0);
  gtk_icon_view_set_orientation (GTK_ICON_VIEW (output_iview), GTK_ORIENTATION_HORIZONTAL);

  label16 = gtk_label_new (_("         "));
  gtk_widget_show (label16);
  gtk_box_pack_start (GTK_BOX (hbox1), label16, FALSE, FALSE, 0);

  setting_notebook = gtk_notebook_new ();
  gtk_widget_show (setting_notebook);
  gtk_box_pack_start (GTK_BOX (hbox1), setting_notebook, TRUE, TRUE, 0);

  frame1 = gtk_frame_new (NULL);
  gtk_widget_show (frame1);
  gtk_container_add (GTK_CONTAINER (setting_notebook), frame1);
  gtk_frame_set_shadow_type (GTK_FRAME (frame1), GTK_SHADOW_ETCHED_OUT);

  hbox5 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox5);
  gtk_container_add (GTK_CONTAINER (frame1), hbox5);

  table3 = gtk_table_new (2, 2, FALSE);
  gtk_widget_show (table3);
  gtk_box_pack_start (GTK_BOX (hbox5), table3, TRUE, TRUE, 0);

  label24 = gtk_label_new (_("  Modes  "));
  gtk_widget_show (label24);
  gtk_table_attach (GTK_TABLE (table3), label24, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label24), 0, 0.5);

  modes_combo = gtk_combo_box_entry_new_text ();
  gtk_widget_show (modes_combo);
  gtk_table_attach (GTK_TABLE (table3), modes_combo, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

  vbox6 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox6);
  gtk_table_attach (GTK_TABLE (table3), vbox6, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);

  label32 = gtk_label_new ("");
  gtk_widget_show (label32);
  gtk_box_pack_start (GTK_BOX (vbox6), label32, FALSE, FALSE, 0);

  auto_cbtn = gtk_check_button_new_with_mnemonic (_("Auto"));
  gtk_widget_show (auto_cbtn);
  gtk_box_pack_start (GTK_BOX (vbox6), auto_cbtn, FALSE, FALSE, 0);

  label33 = gtk_label_new ("");
  gtk_widget_show (label33);
  gtk_box_pack_start (GTK_BOX (vbox6), label33, FALSE, FALSE, 0);

  off_cbtn = gtk_check_button_new_with_mnemonic (_("Off"));
  gtk_widget_show (off_cbtn);
  gtk_box_pack_start (GTK_BOX (vbox6), off_cbtn, FALSE, FALSE, 0);

  label6 = gtk_label_new (_("Settings"));
  gtk_widget_show (label6);
  gtk_frame_set_label_widget (GTK_FRAME (frame1), label6);
  gtk_label_set_use_markup (GTK_LABEL (label6), TRUE);

  label2 = gtk_label_new (_("Basic"));
  gtk_widget_show (label2);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (setting_notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (setting_notebook), 0), label2);

  frame4 = gtk_frame_new (NULL);
  gtk_widget_show (frame4);
  gtk_container_add (GTK_CONTAINER (setting_notebook), frame4);
  gtk_frame_set_shadow_type (GTK_FRAME (frame4), GTK_SHADOW_ETCHED_OUT);

  alignment4 = gtk_alignment_new (0.5, 0.5, 1, 1);
  gtk_widget_show (alignment4);
  gtk_container_add (GTK_CONTAINER (frame4), alignment4);
  gtk_alignment_set_padding (GTK_ALIGNMENT (alignment4), 0, 0, 12, 0);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox2);
  gtk_container_add (GTK_CONTAINER (alignment4), hbox2);

  rotation_img = gtk_image_new_from_icon_name ("gtk-go-up", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (rotation_img);
  gtk_box_pack_start (GTK_BOX (hbox2), rotation_img, TRUE, TRUE, 0);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox3);
  gtk_box_pack_start (GTK_BOX (hbox2), vbox3, TRUE, TRUE, 0);

  rotation0_rbtn = gtk_radio_button_new_with_mnemonic (NULL, _("Normal"));
  gtk_widget_show (rotation0_rbtn);
  gtk_box_pack_start (GTK_BOX (vbox3), rotation0_rbtn, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (rotation0_rbtn, FALSE);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (rotation0_rbtn), rotation0_rbtn_group);
  rotation0_rbtn_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (rotation0_rbtn));

  rotation90_rbtn = gtk_radio_button_new_with_mnemonic (NULL, _("left"));
  gtk_widget_show (rotation90_rbtn);
  gtk_box_pack_start (GTK_BOX (vbox3), rotation90_rbtn, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (rotation90_rbtn, FALSE);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (rotation90_rbtn), rotation0_rbtn_group);
  rotation0_rbtn_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (rotation90_rbtn));

  rotation180_rbtn = gtk_radio_button_new_with_mnemonic (NULL, _("inverted"));
  gtk_widget_show (rotation180_rbtn);
  gtk_box_pack_start (GTK_BOX (vbox3), rotation180_rbtn, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (rotation180_rbtn, FALSE);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (rotation180_rbtn), rotation0_rbtn_group);
  rotation0_rbtn_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (rotation180_rbtn));

  rotation270_rbtn = gtk_radio_button_new_with_mnemonic (NULL, _("right"));
  gtk_widget_show (rotation270_rbtn);
  gtk_box_pack_start (GTK_BOX (vbox3), rotation270_rbtn, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (rotation270_rbtn, FALSE);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (rotation270_rbtn), rotation0_rbtn_group);
  rotation0_rbtn_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (rotation270_rbtn));

  label13 = gtk_label_new (_("Rotation Views"));
  gtk_widget_show (label13);
  gtk_frame_set_label_widget (GTK_FRAME (frame4), label13);
  gtk_label_set_use_markup (GTK_LABEL (label13), TRUE);

  label3 = gtk_label_new (_("Rotation"));
  gtk_widget_show (label3);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (setting_notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (setting_notebook), 1), label3);

  frame3 = gtk_frame_new (NULL);
  gtk_widget_show (frame3);
  gtk_container_add (GTK_CONTAINER (setting_notebook), frame3);
  gtk_frame_set_shadow_type (GTK_FRAME (frame3), GTK_SHADOW_ETCHED_OUT);

  alignment3 = gtk_alignment_new (0.5, 0.5, 1, 1);
  gtk_widget_show (alignment3);
  gtk_container_add (GTK_CONTAINER (frame3), alignment3);
  gtk_alignment_set_padding (GTK_ALIGNMENT (alignment3), 0, 0, 12, 0);

  vbox5 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox5);
  gtk_container_add (GTK_CONTAINER (alignment3), vbox5);

  hbox4 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox4);
  gtk_box_pack_start (GTK_BOX (vbox5), hbox4, TRUE, TRUE, 0);

  clone_rbtn = gtk_radio_button_new_with_mnemonic (NULL, _("Clone"));
  gtk_widget_show (clone_rbtn);
  gtk_box_pack_start (GTK_BOX (hbox4), clone_rbtn, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (clone_rbtn, FALSE);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (clone_rbtn), clone_rbtn_group);
  clone_rbtn_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (clone_rbtn));

  panorama_rbtn = gtk_radio_button_new_with_mnemonic (NULL, _("Extend"));
  gtk_widget_show (panorama_rbtn);
  gtk_box_pack_start (GTK_BOX (hbox4), panorama_rbtn, FALSE, FALSE, 0);
  gtk_widget_set_sensitive (panorama_rbtn, FALSE);
  gtk_radio_button_set_group (GTK_RADIO_BUTTON (panorama_rbtn), clone_rbtn_group);
  clone_rbtn_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (panorama_rbtn));

  label31 = gtk_label_new (_("Drag output icon to desired position"));
  gtk_widget_show (label31);
  gtk_box_pack_start (GTK_BOX (vbox5), label31, FALSE, FALSE, 0);

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (vbox5), hseparator1, TRUE, TRUE, 0);

  table5 = gtk_table_new (5, 5, FALSE);
  gtk_widget_show (table5);
  gtk_box_pack_start (GTK_BOX (vbox5), table5, TRUE, TRUE, 0);

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow2);
  gtk_table_attach (GTK_TABLE (table5), scrolledwindow2, 2, 3, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_SHADOW_IN);

  center_iview = gtk_icon_view_new ();
  gtk_widget_show (center_iview);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), center_iview);
  gtk_icon_view_set_orientation (GTK_ICON_VIEW (center_iview), GTK_ORIENTATION_HORIZONTAL);
  gtk_icon_view_set_reorderable (GTK_ICON_VIEW (center_iview), TRUE);

  scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow3);
  gtk_table_attach (GTK_TABLE (table5), scrolledwindow3, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow3), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow3), GTK_SHADOW_IN);

  left_iview = gtk_icon_view_new ();
  gtk_widget_show (left_iview);
  gtk_container_add (GTK_CONTAINER (scrolledwindow3), left_iview);
  gtk_icon_view_set_reorderable (GTK_ICON_VIEW (left_iview), TRUE);

  scrolledwindow4 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow4);
  gtk_table_attach (GTK_TABLE (table5), scrolledwindow4, 4, 5, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow4), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow4), GTK_SHADOW_IN);

  right_iview = gtk_icon_view_new ();
  gtk_widget_show (right_iview);
  gtk_container_add (GTK_CONTAINER (scrolledwindow4), right_iview);
  gtk_icon_view_set_reorderable (GTK_ICON_VIEW (right_iview), TRUE);

  scrolledwindow5 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow5);
  gtk_table_attach (GTK_TABLE (table5), scrolledwindow5, 2, 3, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow5), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow5), GTK_SHADOW_IN);

  above_iview = gtk_icon_view_new ();
  gtk_widget_show (above_iview);
  gtk_container_add (GTK_CONTAINER (scrolledwindow5), above_iview);
  gtk_icon_view_set_reorderable (GTK_ICON_VIEW (above_iview), TRUE);

  scrolledwindow6 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow6);
  gtk_table_attach (GTK_TABLE (table5), scrolledwindow6, 2, 3, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow6), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow6), GTK_SHADOW_IN);

  below_iview = gtk_icon_view_new ();
  gtk_widget_show (below_iview);
  gtk_container_add (GTK_CONTAINER (scrolledwindow6), below_iview);
  gtk_icon_view_set_reorderable (GTK_ICON_VIEW (below_iview), TRUE);

  label27 = gtk_label_new ("");
  gtk_widget_show (label27);
  gtk_table_attach (GTK_TABLE (table5), label27, 2, 3, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label27), 0, 0.5);

  label28 = gtk_label_new (_("    "));
  gtk_widget_show (label28);
  gtk_table_attach (GTK_TABLE (table5), label28, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label28), 0, 0.5);

  label29 = gtk_label_new (_("    "));
  gtk_widget_show (label29);
  gtk_table_attach (GTK_TABLE (table5), label29, 3, 4, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label29), 0, 0.5);

  label30 = gtk_label_new ("");
  gtk_widget_show (label30);
  gtk_table_attach (GTK_TABLE (table5), label30, 2, 3, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label30), 0, 0.5);

  label8 = gtk_label_new (_("Output Layout"));
  gtk_widget_show (label8);
  gtk_frame_set_label_widget (GTK_FRAME (frame3), label8);
  gtk_label_set_use_markup (GTK_LABEL (label8), TRUE);

  label4 = gtk_label_new (_("Layout"));
  gtk_widget_show (label4);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (setting_notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (setting_notebook), 2), label4);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox4);
  gtk_container_add (GTK_CONTAINER (setting_notebook), vbox4);

  hotkey_cbtn = gtk_check_button_new_with_mnemonic (_("Enable Hot Keys"));
  gtk_widget_show (hotkey_cbtn);
  gtk_box_pack_start (GTK_BOX (vbox4), hotkey_cbtn, FALSE, FALSE, 0);

  hotkey_tview = gtk_tree_view_new ();
  gtk_widget_show (hotkey_tview);
  gtk_box_pack_start (GTK_BOX (vbox4), hotkey_tview, TRUE, TRUE, 0);

  label5 = gtk_label_new (_("Hot Keys"));
  gtk_widget_show (label5);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (setting_notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (setting_notebook), 3), label5);

  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_show (hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbuttonbox1, FALSE, TRUE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox1), GTK_BUTTONBOX_END);

  ok_btn = gtk_button_new_with_mnemonic (_("OK"));
  gtk_widget_show (ok_btn);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), ok_btn);
  GTK_WIDGET_SET_FLAGS (ok_btn, GTK_CAN_DEFAULT);

  cancel_btn = gtk_button_new_with_mnemonic (_("Cancel"));
  gtk_widget_show (cancel_btn);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), cancel_btn);
  GTK_WIDGET_SET_FLAGS (cancel_btn, GTK_CAN_DEFAULT);

  apply_btn = gtk_button_new_with_mnemonic (_("Apply"));
  gtk_widget_show (apply_btn);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), apply_btn);
  GTK_WIDGET_SET_FLAGS (apply_btn, GTK_CAN_DEFAULT);

  g_signal_connect ((gpointer) about_btn, "clicked",
                    G_CALLBACK (on_about_btn_clicked),
                    NULL);
  g_signal_connect ((gpointer) output_iview, "selection_changed",
                    G_CALLBACK (on_output_iview_selection_changed),
                    NULL);
  g_signal_connect ((gpointer) modes_combo, "changed",
                    G_CALLBACK (on_modes_combo_changed),
                    NULL);
  g_signal_connect ((gpointer) auto_cbtn, "toggled",
                    G_CALLBACK (on_auto_cbtn_toggled),
                    NULL);
  g_signal_connect ((gpointer) off_cbtn, "toggled",
                    G_CALLBACK (on_off_cbtn_toggled),
                    NULL);
  g_signal_connect ((gpointer) rotation0_rbtn, "pressed",
                    G_CALLBACK (on_rotation0_rbtn_pressed),
                    NULL);
  g_signal_connect ((gpointer) rotation90_rbtn, "pressed",
                    G_CALLBACK (on_rotation90_rbtn_pressed),
                    NULL);
  g_signal_connect ((gpointer) rotation180_rbtn, "pressed",
                    G_CALLBACK (on_rotation180_rbtn_pressed),
                    NULL);
  g_signal_connect ((gpointer) rotation270_rbtn, "pressed",
                    G_CALLBACK (on_rotation270_rbtn_pressed),
                    NULL);
  g_signal_connect ((gpointer) clone_rbtn, "pressed",
                    G_CALLBACK (on_clone_rbtn_pressed),
                    NULL);
  g_signal_connect ((gpointer) panorama_rbtn, "pressed",
                    G_CALLBACK (on_panorama_rbtn_pressed),
                    NULL);
  g_signal_connect ((gpointer) hotkey_cbtn, "toggled",
                    G_CALLBACK (on_hotkey_cbtn_toggled),
                    NULL);
  g_signal_connect ((gpointer) ok_btn, "clicked",
                    G_CALLBACK (on_ok_btn_clicked),
                    NULL);
  g_signal_connect ((gpointer) cancel_btn, "clicked",
                    G_CALLBACK (gtk_main_quit),
                    NULL);
  g_signal_connect ((gpointer) apply_btn, "clicked",
                    G_CALLBACK (on_apply_btn_clicked),
                    NULL);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (main_win, main_win, "main_win");
  GLADE_HOOKUP_OBJECT (main_win, vbox1, "vbox1");
  GLADE_HOOKUP_OBJECT (main_win, hbox3, "hbox3");
  GLADE_HOOKUP_OBJECT (main_win, label15, "label15");
  GLADE_HOOKUP_OBJECT (main_win, xserver_entry, "xserver_entry");
  GLADE_HOOKUP_OBJECT (main_win, label34, "label34");
  GLADE_HOOKUP_OBJECT (main_win, about_btn, "about_btn");
  GLADE_HOOKUP_OBJECT (main_win, label17, "label17");
  GLADE_HOOKUP_OBJECT (main_win, hbox1, "hbox1");
  GLADE_HOOKUP_OBJECT (main_win, scrolledwindow1, "scrolledwindow1");
  GLADE_HOOKUP_OBJECT (main_win, viewport1, "viewport1");
  GLADE_HOOKUP_OBJECT (main_win, vbox2, "vbox2");
  GLADE_HOOKUP_OBJECT (main_win, label9, "label9");
  GLADE_HOOKUP_OBJECT (main_win, output_iview, "output_iview");
  GLADE_HOOKUP_OBJECT (main_win, label16, "label16");
  GLADE_HOOKUP_OBJECT (main_win, setting_notebook, "setting_notebook");
  GLADE_HOOKUP_OBJECT (main_win, frame1, "frame1");
  GLADE_HOOKUP_OBJECT (main_win, hbox5, "hbox5");
  GLADE_HOOKUP_OBJECT (main_win, table3, "table3");
  GLADE_HOOKUP_OBJECT (main_win, label24, "label24");
  GLADE_HOOKUP_OBJECT (main_win, modes_combo, "modes_combo");
  GLADE_HOOKUP_OBJECT (main_win, vbox6, "vbox6");
  GLADE_HOOKUP_OBJECT (main_win, label32, "label32");
  GLADE_HOOKUP_OBJECT (main_win, auto_cbtn, "auto_cbtn");
  GLADE_HOOKUP_OBJECT (main_win, label33, "label33");
  GLADE_HOOKUP_OBJECT (main_win, off_cbtn, "off_cbtn");
  GLADE_HOOKUP_OBJECT (main_win, label6, "label6");
  GLADE_HOOKUP_OBJECT (main_win, label2, "label2");
  GLADE_HOOKUP_OBJECT (main_win, frame4, "frame4");
  GLADE_HOOKUP_OBJECT (main_win, alignment4, "alignment4");
  GLADE_HOOKUP_OBJECT (main_win, hbox2, "hbox2");
  GLADE_HOOKUP_OBJECT (main_win, rotation_img, "rotation_img");
  GLADE_HOOKUP_OBJECT (main_win, vbox3, "vbox3");
  GLADE_HOOKUP_OBJECT (main_win, rotation0_rbtn, "rotation0_rbtn");
  GLADE_HOOKUP_OBJECT (main_win, rotation90_rbtn, "rotation90_rbtn");
  GLADE_HOOKUP_OBJECT (main_win, rotation180_rbtn, "rotation180_rbtn");
  GLADE_HOOKUP_OBJECT (main_win, rotation270_rbtn, "rotation270_rbtn");
  GLADE_HOOKUP_OBJECT (main_win, label13, "label13");
  GLADE_HOOKUP_OBJECT (main_win, label3, "label3");
  GLADE_HOOKUP_OBJECT (main_win, frame3, "frame3");
  GLADE_HOOKUP_OBJECT (main_win, alignment3, "alignment3");
  GLADE_HOOKUP_OBJECT (main_win, vbox5, "vbox5");
  GLADE_HOOKUP_OBJECT (main_win, hbox4, "hbox4");
  GLADE_HOOKUP_OBJECT (main_win, clone_rbtn, "clone_rbtn");
  GLADE_HOOKUP_OBJECT (main_win, panorama_rbtn, "panorama_rbtn");
  GLADE_HOOKUP_OBJECT (main_win, label31, "label31");
  GLADE_HOOKUP_OBJECT (main_win, hseparator1, "hseparator1");
  GLADE_HOOKUP_OBJECT (main_win, table5, "table5");
  GLADE_HOOKUP_OBJECT (main_win, scrolledwindow2, "scrolledwindow2");
  GLADE_HOOKUP_OBJECT (main_win, center_iview, "center_iview");
  GLADE_HOOKUP_OBJECT (main_win, scrolledwindow3, "scrolledwindow3");
  GLADE_HOOKUP_OBJECT (main_win, left_iview, "left_iview");
  GLADE_HOOKUP_OBJECT (main_win, scrolledwindow4, "scrolledwindow4");
  GLADE_HOOKUP_OBJECT (main_win, right_iview, "right_iview");
  GLADE_HOOKUP_OBJECT (main_win, scrolledwindow5, "scrolledwindow5");
  GLADE_HOOKUP_OBJECT (main_win, above_iview, "above_iview");
  GLADE_HOOKUP_OBJECT (main_win, scrolledwindow6, "scrolledwindow6");
  GLADE_HOOKUP_OBJECT (main_win, below_iview, "below_iview");
  GLADE_HOOKUP_OBJECT (main_win, label27, "label27");
  GLADE_HOOKUP_OBJECT (main_win, label28, "label28");
  GLADE_HOOKUP_OBJECT (main_win, label29, "label29");
  GLADE_HOOKUP_OBJECT (main_win, label30, "label30");
  GLADE_HOOKUP_OBJECT (main_win, label8, "label8");
  GLADE_HOOKUP_OBJECT (main_win, label4, "label4");
  GLADE_HOOKUP_OBJECT (main_win, vbox4, "vbox4");
  GLADE_HOOKUP_OBJECT (main_win, hotkey_cbtn, "hotkey_cbtn");
  GLADE_HOOKUP_OBJECT (main_win, hotkey_tview, "hotkey_tview");
  GLADE_HOOKUP_OBJECT (main_win, label5, "label5");
  GLADE_HOOKUP_OBJECT (main_win, hbuttonbox1, "hbuttonbox1");
  GLADE_HOOKUP_OBJECT (main_win, ok_btn, "ok_btn");
  GLADE_HOOKUP_OBJECT (main_win, cancel_btn, "cancel_btn");
  GLADE_HOOKUP_OBJECT (main_win, apply_btn, "apply_btn");

  return main_win;
}

